## ada-reference-manual 2012.1

=== build/Makefile ===
# Build info version of Ada RM, orig.tar.gz for Debian package, and tar.gz for my web page

# see ../README.txt for list of things to change when scheme or Ada source changes.
#
# On Windows, use MikTex, not Cygwin tex (at least not version texi2dvi (GNU Texinfo 4.13) 1.135)

DEBIAN_VERSION := 2012.1
ZIP_DATE       := 20120428

# debian-free is _not_ in all
all : html info pdf TXT publish

html : html/arm2012/RM-TOC.html
html : html/aarm2012/AA-TOC.html
html : html/arm2005/RM-TOC.html
html : html/aarm2005/AA-TOC.html
info : arm2012.info
info : aarm2012.info
info : arm2005.info
info : aarm2005.info
pdf  : arm2012.pdf
pdf  : aarm2012.pdf
pdf  : arm2005.pdf
pdf  : aarm2005.pdf
TXT  : txt/arm2012/RM-TOC.TXT
TXT  : txt/aarm2012/AA-TOC.TXT
TXT  : txt/arm2005/RM-TOC.TXT
TXT  : txt/aarm2005/AA-TOC.TXT

# We have been unable to get rid of all the section ref violations, so we
# specify --no-validate. Delete that to see the errors.
TEXI_INFO_OPTS := --no-split --no-number-sections --no-validate
TEXI_DVI_OPTS := --quiet

arm2012.texinfo : arm_form.exe
	cd ../source; ../build/arm_form.exe RM info New-Only 3
	mv ../source/RM.texinfo ./arm2012.texinfo

arm2005.texinfo : arm_form.exe
	cd ../source_2005; ../build/arm_form.exe RM info New-Only 2
	mv ../source_2005/RM.texinfo ./arm2005.texinfo

aarm2012.texinfo : arm_form.exe
	cd ../source; ../build/arm_form.exe AARM info New-Only 3
	mv ../source/AA.texinfo ./aarm2012.texinfo

aarm2005.texinfo : arm_form.exe
	cd ../source_2005; ../build/arm_form.exe AARM info New-Only 2
	mv ../source_2005/AA.texinfo ./aarm2005.texinfo

html/arm2012/RM-TOC.html : arm_form.exe | html/arm2012 ../source/Output
	cd ../source; ../build/arm_form.exe RM HTML New-Only 3
	rm -rf html/arm2012/*
	mv ../source/Output/* html/arm2012

html/arm2005/RM-TOC.html : arm_form.exe | html/arm2005 ../source_2005/Output
	cd ../source_2005; ../build/arm_form.exe RM HTML New-Only 2
	rm -rf html/arm2005/*
	mv ../source_2005/Output/* html/arm2005

html/aarm2012/AA-TOC.html : arm_form.exe | html/aarm2012 ../source/Output
	cd ../source; ../build/arm_form.exe AARM HTML New-Only 3
	rm -rf html/aarm2012/*
	mv ../source/Output/* html/aarm2012

html/aarm2005/AA-TOC.html : arm_form.exe | html/aarm2005 ../source_2005/Output
	cd ../source_2005; ../build/arm_form.exe AARM HTML New-Only 2
	rm -rf html/aarm2005/*
	mv ../source_2005/Output/* html/aarm2005

txt/arm2012/RM-TOC.TXT : arm_form.exe | txt/arm2012 ../source/Output
	cd ../source; ../build/arm_form.exe RM Text New-Only 3
	rm -rf txt/arm2012/*
	mv ../source/Output/* txt/arm2012

txt/arm2005/RM-TOC.TXT : arm_form.exe | txt/arm2005 ../source_2005/Output
	cd ../source_2005; ../build/arm_form.exe RM Text New-Only 2
	rm -rf txt/arm2005/*
	mv ../source_2005/Output/* txt/arm2005

txt/aarm2012/AA-TOC.TXT : arm_form.exe | txt/aarm2012 ../source/Output
	cd ../source; ../build/arm_form.exe AARM Text New-Only 3
	rm -rf txt/aarm2012/*
	mv ../source/Output/* txt/aarm2012

txt/aarm2005/AA-TOC.TXT : arm_form.exe | txt/aarm2005 ../source_2005/Output
	cd ../source_2005; ../build/arm_form.exe AARM Text New-Only 2
	rm -rf txt/aarm2005/*
	mv ../source_2005/Output/* txt/aarm2005

arm_form.exe : force
	gnatmake -p -k -P arm_info.gpr

trace :
	addr2line -e arm_form.exe 0x5c12e7 0x5c598e 0x43e05b 0x446c5b 0x448369 0x545205 0x4e9221 0x4e3b1a 0x5831a1 0x5ad295 0x5adee9 0x4cb3f5 0x401850 0x401235 0x401286 0x7c817075

html/arm2005 html/arm2012 html/aarm2005 html/aarm2012 txt/arm2005 txt/arm2012 txt/aarm2005 txt/aarm2012 ../source/Output ../source_2005 ../source_2005/Output :
	mkdir -p $@

publish : publish-info publish-zip

publish-info : aarm2012.info arm2012.info aarm2005.info arm2005.info
	tar zcf arm2012-$(ZIP_DATE).tar.gz aarm*.info arm*.info

publish-zip : arm_info-$(ZIP_DATE)-src.tar.gz

arm_info-$(ZIP_DATE)-src.tar.gz :
	tar zcf arm_info-$(ZIP_DATE)-src.tar.gz -C ../.. --exclude "*~" --exclude "*.dvi" --exclude "*.gz" --exclude "*.info" --exclude "*.log" --exclude "*.pdf" --exclude "*.ps" --exclude "*.texinfo" --exclude "*.toc" --exclude "*.stamp" --exclude "*.zip" --exclude html --exclude objects --exclude txt --exclude arm_form.exe --exclude _MTN --exclude .mtn-ignore --exclude=.dvc-exclude org.adaic.arm_form

# starting from a mtn checkout of org.adaic.arm_form, generate the Debian source tarball, set up for building Debian package
# ../../ada-reference-manual-2012.1-current/ada-reference-manual-2012.1/debian/rules
debian-free : debian-clean debian-update
	mtn checkout --branch org.debian.ada-reference-manual ../../ada-reference-manual-$(DEBIAN_VERSION)-current/ada-reference-manual-$(DEBIAN_VERSION)
	cd ../../ada-reference-manual-$(DEBIAN_VERSION)-current; tar jxf ada-reference-manual_$(DEBIAN_VERSION).orig.tar.bz2

debian-zip : ada-reference-manual_$(DEBIAN_VERSION).orig.tar.bz2

# we include the 2005 scheme source in the Debian tarball; simpler than including 2005-SRC.zip
ada-reference-manual_$(DEBIAN_VERSION).orig.tar.bz2 : source_scheme_2005.stamp
	rm -rf ../../ada-reference-manual-$(DEBIAN_VERSION)
	mtn checkout --branch org.adaic.arm_form ../../ada-reference-manual-$(DEBIAN_VERSION)
	cp -r ../source_2005 ../../ada-reference-manual-$(DEBIAN_VERSION)
	tar -c -O  -C ../.. --exclude _MTN --exclude .mtn-ignore --no-anchor ada-reference-manual-$(DEBIAN_VERSION) | bzip2 -9 > ada-reference-manual_$(DEBIAN_VERSION).orig.tar.bz2

debian-update : ada-reference-manual_$(DEBIAN_VERSION).orig.tar.bz2
debian-update : | ../../ada-reference-manual-$(DEBIAN_VERSION)-current
	cp $^ ../../ada-reference-manual-$(DEBIAN_VERSION)-current/

debian-clean :
	rm ada-reference-manual_$(DEBIAN_VERSION).orig.tar.bz2
	rm -rf ../../ada-reference-manual-$(DEBIAN_VERSION)-current

../../ada-reference-manual-$(DEBIAN_VERSION)-current :
	mkdir -p $@

# This retrieves CVS HEAD, for both Ada and Scheme source, for the
# next Ada version (dvc-status "../../org.adaic.arm_form.upstream")
#
update-upstream : source_ada.clean source_scheme.clean source_ada.stamp source_scheme.stamp

UPSTREAM_ADA := arm_cont.adb
UPSTREAM_ADA += arm_cont.ads
UPSTREAM_ADA += arm_corr.adb
UPSTREAM_ADA += arm_corr.ads
UPSTREAM_ADA += arm_db.adb
UPSTREAM_ADA += arm_db.ads
UPSTREAM_ADA += arm_file.adb
UPSTREAM_ADA += arm_file.ads
UPSTREAM_ADA += arm_form.ada
UPSTREAM_ADA += arm_frm.adb
UPSTREAM_ADA += arm_frm.ads
UPSTREAM_ADA += arm_frmd.adb
UPSTREAM_ADA += arm_frmd.ads
UPSTREAM_ADA += arm_frms.adb
UPSTREAM_ADA += arm_html.adb
UPSTREAM_ADA += arm_html.ads
UPSTREAM_ADA += arm_indx.adb
UPSTREAM_ADA += arm_indx.ads
UPSTREAM_ADA += arm_inp.adb
UPSTREAM_ADA += arm_inp.ads
UPSTREAM_ADA += arm_mast.adb
UPSTREAM_ADA += arm_mast.ads
UPSTREAM_ADA += arm_out.ads
UPSTREAM_ADA += arm_rtf.adb
UPSTREAM_ADA += arm_rtf.ads
UPSTREAM_ADA += arm_str.adb
UPSTREAM_ADA += arm_str.ads
UPSTREAM_ADA += arm_sub.adb
UPSTREAM_ADA += arm_sub.ads
UPSTREAM_ADA += arm_syn.adb
UPSTREAM_ADA += arm_syn.ads
UPSTREAM_ADA += arm_texi.adb
UPSTREAM_ADA += arm_texi.ads
UPSTREAM_ADA += arm_text.adb
UPSTREAM_ADA += arm_text.ads

# We do not convert to unix line endings here to minimize the diff
# with upstream; the Ada compiler on Debian can handle DOS line
# endings.
source_ada.stamp :
	for file in $(UPSTREAM_ADA); do wget -nv -O ../../org.adaic.arm_form.upstream/progs/$$file "http://www.ada-auth.org/cgi-bin/cvsweb.cgi/arm/progs/$$file?rev=HEAD"; done
	touch source_ada.stamp

source_ada.clean :
	rm -f source_ada.stamp

UPSTREAM_SCHEME := 01.MSS
UPSTREAM_SCHEME += 02.MSS
UPSTREAM_SCHEME += 03A.MSS
UPSTREAM_SCHEME += 03B.MSS
UPSTREAM_SCHEME += 03C.MSS
UPSTREAM_SCHEME += 04A.MSS
UPSTREAM_SCHEME += 04B.MSS
UPSTREAM_SCHEME += 05.MSS
UPSTREAM_SCHEME += 06.MSS
UPSTREAM_SCHEME += 07.MSS
UPSTREAM_SCHEME += 08.MSS
UPSTREAM_SCHEME += 09.MSS
UPSTREAM_SCHEME += 10.MSS
UPSTREAM_SCHEME += 11.MSS
UPSTREAM_SCHEME += 12.MSS
UPSTREAM_SCHEME += 13A.MSS
UPSTREAM_SCHEME += 13B.MSS
UPSTREAM_SCHEME += AARM.MSM
UPSTREAM_SCHEME += ATTRIBS.MSS
UPSTREAM_SCHEME += DS.MSS
UPSTREAM_SCHEME += GLOSSARY.MSS
UPSTREAM_SCHEME += IMPLDEF.MSS
UPSTREAM_SCHEME += INDEX.MSS
UPSTREAM_SCHEME += INFOSYS.MSS
UPSTREAM_SCHEME += LANGDEF.MSS
UPSTREAM_SCHEME += LIBRARY.MSS
UPSTREAM_SCHEME += NUMERICS.MSS
UPSTREAM_SCHEME += PRAGMAS.MSS
UPSTREAM_SCHEME += PRE.MSS
UPSTREAM_SCHEME += PRE_ADA.MSS
UPSTREAM_SCHEME += PRE_DIRS.MSS
UPSTREAM_SCHEME += PRE_IO.MSS
UPSTREAM_SCHEME += PRE_Locales.MSS
UPSTREAM_SCHEME += PRE_MATH.MSS
UPSTREAM_SCHEME += Pre_Containers.MSS
UPSTREAM_SCHEME += Pre_Con2.MSS
UPSTREAM_SCHEME += Pre_Environ.MSS
UPSTREAM_SCHEME += Pre_Con2.MSS
UPSTREAM_SCHEME += RM.MSM
UPSTREAM_SCHEME += RT.MSS
UPSTREAM_SCHEME += Real_attribs.mss
UPSTREAM_SCHEME += SAFETY.MSS
UPSTREAM_SCHEME += SP.MSS
UPSTREAM_SCHEME += SYNTAX.MSS
UPSTREAM_SCHEME += TITLE.MSS
UPSTREAM_SCHEME += ansi_cover.mss
UPSTREAM_SCHEME += ansi_title.mss
UPSTREAM_SCHEME += front_matter.mss
UPSTREAM_SCHEME += interface.mss
UPSTREAM_SCHEME += iso-rm.msm
UPSTREAM_SCHEME += obsolescent.mss
UPSTREAM_SCHEME += pre_chars.mss
UPSTREAM_SCHEME += pre_cmdln.mss
UPSTREAM_SCHEME += pre_standard.mss
UPSTREAM_SCHEME += pre_strings.mss

# This retrieves CVS HEAD, for the next Ada version (commit to mtn branch org.adaic.arm_form.upstream)
#
# We convert to unix line endings because the scheme processor insists
# on uniform formatting; this works for both Windows and Debian.
source_scheme.stamp :
	for file in $(UPSTREAM_SCHEME); do wget -nv -O ../../org.adaic.arm_form.upstream/source/$$file "http://www.ada-auth.org/cgi-bin/cvsweb.cgi/arm/source/$$file?rev=HEAD"; done
	cd ../../org.adaic.arm_form.upstream/source; $(CURDIR)/convert_to_unix.sh
	touch source_scheme.stamp

source_scheme.clean :
	rm -f source_scheme.stamp

2005-SRC.zip :
	wget http://www.ada-auth.org/arm-files/2005-SRC.zip

source_scheme_2005.stamp : 2005-SRC.zip | ../source_2005
	rm -rf ../source_2005/*
	cd ../source_2005; unzip ../build/2005-SRC.zip; rm arm_form.exe; $(CURDIR)/convert_to_unix.sh
	cd ../source_2005; patch -p 1 < ../build/source_2005.diff
	touch source_scheme_2005.stamp

../source_2005_orig :
	cd ../source_2005_orig; unzip ../build/2005-SRC.zip; rm arm_form.exe; $(CURDIR)/convert_to_unix.sh

source_2005.diff : ../source_2005_orig
	-cd ../; diff -u source_2005_orig source_2005 > build/source_2005.diff

# delete everything back to mtn checkout plus source_2005.
clean ::
	rm 2005-SRC.zip
	rm -rf objects html txt
	rm -f *.dvi *.info* *.texinfo *.log *.pdf *.stamp *.tar.gz *.toc *.zip
	rm -rf ../source/Output ../source_2005/Output

info-clean :
	rm -f *.info*

.PHONY : force
#include ../../../GDS/main/makerules/common_rules.make
#include ../../../GDS/main/makerules/gnat_project_rules.make

# This produces a PDF, but it has no hyperlinks, so it is suitable
# only for printing.
%.dvi : %.texinfo
	texi2dvi $(TEXI_DVI_OPTS) $<

%.ps : %.dvi
	dvips $<

%.pdf : %.ps
	ps2pdf $<

# we don't want all the rules in texinfo_rules.make; they collide with latex_rules.make.
%.info : %.texinfo
	makeinfo $(TEXI_INFO_OPTS) $<

VPATH = ../source ../progs

#Local Variables:
#eval: (ada-parse-prj-file "arm_info.prj")
#eval: (ada-select-prj-file "arm_info.prj")
#eval: (makefile-mode)
#End:
# end of file

## ada-reference-manual 2005.2

=== debian/changelog ===
ada-reference-manual (1:2005.2-1) unstable; urgency=low

  * New upstream release, dated 12 Nov 2006, for Ada 2005. HTML, info,
    PDF, and text files generated from texinfo sources, which are
    generated upstream from Scheme sources. Split into several packages to
    allow users to only install the format they want. Closes: #460582

 -- Stephen Leake <stephen_leake@stephe-leake.org>  Sun, 06 Jun 2010 16:52:31 -0400

ada-reference-manual (20021112web-3) unstable; urgency=low

  * Correctly represent '@' characters in the Texinfo manual.
    Closes: #287517.

 -- Florian Weimer <fw@deneb.enyo.de>  Tue, 28 Dec 2004 15:17:16 +0100

ada-reference-manual (20021112web-2) unstable; urgency=low

  * The address in the Texinfo file is no longer the preferred one.  Add a
    remark.  Closes: #258053.

 -- Florian Weimer <fw@deneb.enyo.de>  Wed,  7 Jul 2004 22:23:53 +0200

ada-reference-manual (20021112web-1) unstable; urgency=low

  * First version. Closes: #168766.

 -- Florian Weimer <fw@deneb.enyo.de>  Sat, 11 Jan 2003 18:00:18 +0100

=== debian/control ===
Source: ada-reference-manual
Section: doc
Priority: optional
Maintainer: Stephen Leake <stephen_leake@stephe-leake.org>
DM-Upload-Allowed: yes
# texlive-base          lots of tex stuff used by texi2dvi
# texlive-binaries      dvips
# texlive-latex-base    fonts used by our doc
# texinfo               texi2dvi
# ghostscript           ps2pdf
Build-Depends: debhelper (>= 7)
Build-Depends-Indep: texinfo, texlive-base, texlive-binaries, texlive-latex-base, ghostscript
Standards-Version: 3.8.4
Homepage: http://www.stephe-leake.org/ada/arm.html

Package: ada-reference-manual-html
Architecture: all
Conflicts: gnat-doc (<< 3.15p)
Suggests: gnat, ada-compiler
Depends: ${misc:Depends}
Description: Ada 2005 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions in HTML
 format.

Package: ada-reference-manual-info
Architecture: all
Conflicts: gnat-doc (<< 3.15p)
Suggests: gnat, ada-compiler
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Description: Ada 2005 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions in info
 format.

Package: ada-reference-manual-pdf
Architecture: all
Conflicts: gnat-doc (<< 3.15p)
Suggests: gnat, ada-compiler
Depends: ${misc:Depends}
Description: Ada 2005 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions in PDF format.

Package: ada-reference-manual-text
Architecture: all
Conflicts: gnat-doc (<< 3.15p)
Suggests: gnat, ada-compiler
Depends: ${misc:Depends}
Description: Ada 2005 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions in plain text
 format.

=== debian/rules ===
#!/usr/bin/make -f
#
# Debian Makefile for ada-reference-manual
# Copyright (c) 2010 Stephen Leake <stephen_leake@stephe-leake.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# To build this package in a chroot:
# schroot -d `cd ..; pwd` --chroot=unstable -- dpkg-buildpackage -uc -us -i"_MTN|\\.mtn-ignore"
#
# To run lintian:
# schroot -d `cd ..; pwd` --chroot=unstable -- make -f debian/rules lint

.SUFFIXES=

# Targets mandated by the Debian Policy

.PHONY: build binary binary-arch binary-indep clean

build: build-stamp

build-stamp: debian/tmp/arm2005-html
build-stamp: debian/tmp/aarm2005-html
build-stamp: debian/tmp/arm2005.info
build-stamp: debian/tmp/aarm2005.info
build-stamp: debian/tmp/arm2005.pdf
build-stamp: debian/tmp/aarm2005.pdf
build-stamp: debian/tmp/arm2005.text
build-stamp: debian/tmp/aarm2005.text
	touch build-stamp

debian/tmp/%-html : %.texinfo | debian/tmp
	makeinfo --html --no-validate --no-number-sections $< -o $@

debian/tmp/%.info : %.texinfo | debian/tmp
	makeinfo --no-validate --no-split --no-number-sections $< -o $@

debian/tmp/%.dvi : %.texinfo | debian/tmp
	cd debian/tmp; texi2dvi --quiet --tidy ../../$<

debian/tmp/%.text : %.texinfo | debian/tmp
	makeinfo --plaintext --no-validate --no-number-sections $< -o $@

debian/tmp :
	mkdir debian/tmp

debian/tmp/%.ps : debian/tmp/%.dvi
	dvips -o $@ $<

debian/tmp/%.pdf : debian/tmp/%.ps
	ps2pdf $< $@

clean:
	dh_clean
	rm -f build-stamp

binary: binary-indep binary-arch

binary-indep:
	dh_installchangelogs
	dh_installdocs -p ada-reference-manual-html debian/tmp/*-html
	dh_installinfo -p ada-reference-manual-info debian/tmp/*.info*
	dh_installdocs -p ada-reference-manual-info debian/copyright
	dh_installdocs -p ada-reference-manual-pdf debian/tmp/*.pdf
	dh_installdocs -p ada-reference-manual-text debian/tmp/*.text
	dh_compress
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# no architecture-dependent files
binary-arch:

lint:
	cd ..; lintian -i ada-reference-manual*.changes

# end of file

## ada-reference-manual 2012.1

=== debian/changelog ===
ada-reference-manual (1:2012.1-2) unstable; urgency=low

  * debian/control (Maintainer): new maintainer as Stephen has retired
    from Debian. Thanks for all the hard work, Stephen.
    (DM-Upload-Allowed): remove, not necessary anymore.
  * (ada-reference-manual-2005): break and replace
    ada-reference-manual-{html,info,pdf,text} from the previous upstream
    version.  Closes: #673321.

 -- Ludovic Brenta <lbrenta@debian.org>  Mon, 11 Jun 2012 09:56:25 +0200

ada-reference-manual (1:2012.1-1) unstable; urgency=low

  * New upstream release, for Ada 2012, draft 17. Scheme sources, and the
    Ada code that processes them, are now included (Ada code license was
    changed by upstream to GPL 3). Both Ada 2005 and Ada 2012 reference
    manuals are generated. Merged all formats into one package per Ada
    version for simplicity.

 -- Stephen Leake <stephen_leake@stephe-leake.org>  Sun, 29 Apr 2012 08:10:00 -0400

=== debian/control ===
Source: ada-reference-manual
Section: doc
Priority: optional
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Build-Depends: debhelper (>= 9)
# ghostscript           ps2pdf
# texinfo               texi2dvi
# texlive-base          lots of tex stuff used by texi2dvi
# texlive-binaries      dvips
# texlive-latex-base    fonts used by our doc
Build-Depends-Indep: ghostscript, texinfo, texlive-base, texlive-binaries, texlive-latex-base,
 gnat
Standards-Version: 3.9.3
Homepage: http://www.stephe-leake.org/ada/arm.html

Package: ada-reference-manual-2005
Architecture: all
Conflicts: gnat-doc (<< 3.15p)
Suggests: gnat
Breaks: ada-reference-manual-html,
 ada-reference-manual-info,
 ada-reference-manual-pdf,
 ada-reference-manual-text
Replaces: ada-reference-manual-html,
 ada-reference-manual-info,
 ada-reference-manual-pdf,
 ada-reference-manual-text
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Description: Ada 2005 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions of the 2005
 ARM in HTML, PDF, info, and plain text formats.

Package: ada-reference-manual-2012
Architecture: all
Conflicts: gnat-doc (<< 3.15p)
Suggests: gnat
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Description: Ada 2012 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions of the 2012
 ARM in HTML, PDF, info, and plain text formats.

=== debian/rules ===
#!/usr/bin/make -f
#
# Debian Makefile for ada-reference-manual
# Copyright (c) 2010, 2012 Stephen Leake <stephen_leake@stephe-leake.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# To setup for building this package from a new upstream release:
# cd /home/Projects/arm_info/org.adaic.arm_form/build/
# make debian-free
# or
# make debian-update
#
# To build this package in a chroot:
# schroot -d `cd ..; pwd` --chroot=unstable -- dpkg-buildpackage -uc -us
#
# To run lintian:
# schroot -d `cd ..; pwd` --chroot=unstable -- make -f debian/rules lint
#
# To test a single target:
# schroot -d `cd ..; pwd` --chroot=unstable -- make -f debian/rules <target>

.SUFFIXES=

# Targets mandated by the Debian Policy

.PHONY: build build-arch build-indep binary binary-arch binary-indep clean force

build: build-indep
build-indep: build-stamp

build-stamp: debian/tmp/arm2005-html
build-stamp: debian/tmp/aarm2005-html
build-stamp: debian/tmp/arm2005.info
build-stamp: debian/tmp/aarm2005.info
build-stamp: debian/tmp/arm2005.pdf
build-stamp: debian/tmp/aarm2005.pdf
build-stamp: debian/tmp/arm2005.text
build-stamp: debian/tmp/aarm2005.text
build-stamp: debian/tmp/arm2012-html
build-stamp: debian/tmp/aarm2012-html
build-stamp: debian/tmp/arm2012.info
build-stamp: debian/tmp/aarm2012.info
build-stamp: debian/tmp/arm2012.pdf
build-stamp: debian/tmp/aarm2012.pdf
build-stamp: debian/tmp/arm2012.text
build-stamp: debian/tmp/aarm2012.text
	touch build-stamp

debian/tmp/arm2005-html : debian/tmp/arm_form.exe | source_2005/Output
	cd source_2005; ../debian/tmp/arm_form.exe RM HTML New-Only 2
	rm -rf $@
	mv source_2005/Output $@
	mkdir source_2005/Output

debian/tmp/aarm2005-html : debian/tmp/arm_form.exe | source_2005/Output
	cd source_2005; ../debian/tmp/arm_form.exe AARM HTML New-Only 2
	rm -rf $@
	mv source_2005/Output $@
	mkdir source_2005/Output

debian/tmp/arm2012-html : debian/tmp/arm_form.exe | source/Output
	cd source; ../debian/tmp/arm_form.exe RM HTML New-Only 3
	rm -rf $@
	mv source/Output $@
	mkdir source/Output

debian/tmp/aarm2012-html : debian/tmp/arm_form.exe | source/Output
	cd source; ../debian/tmp/arm_form.exe AARM HTML New-Only 3
	rm -rf $@
	mv source/Output $@
	mkdir source/Output

debian/tmp/%.info : debian/tmp/%.texinfo | debian/tmp
	makeinfo --no-validate --no-split --no-number-sections $< -o $@

debian/tmp/%.pdf : debian/tmp/%.ps
	ps2pdf $< $@

debian/tmp/arm2005.text : debian/tmp/arm_form.exe | source_2005/Output
	cd source_2005; ../debian/tmp/arm_form.exe RM Text New-Only 2
	rm -rf $@
	mv source_2005/Output $@
	mkdir source_2005/Output

debian/tmp/aarm2005.text : debian/tmp/arm_form.exe | source_2005/Output
	cd source_2005; ../debian/tmp/arm_form.exe AARM Text New-Only 2
	rm -rf $@
	mv source_2005/Output $@
	mkdir source_2005/Output

debian/tmp/arm2012.text : debian/tmp/arm_form.exe | source/Output
	cd source; ../debian/tmp/arm_form.exe RM Text New-Only 3
	rm -rf $@
	mv source/Output $@
	mkdir source/Output

debian/tmp/aarm2012.text : debian/tmp/arm_form.exe | source/Output
	cd source; ../debian/tmp/arm_form.exe AARM Text New-Only 3
	rm -rf $@
	mv source/Output $@
	mkdir source/Output

debian/tmp/arm2005.texinfo : debian/tmp/arm_form.exe
	cd source_2005; ../debian/tmp/arm_form.exe RM info New-Only 2
	mv source_2005/RM.texinfo $@

debian/tmp/aarm2005.texinfo : debian/tmp/arm_form.exe
	cd source_2005; ../debian/tmp/arm_form.exe AARM info New-Only 2
	mv source_2005/AA.texinfo $@

debian/tmp/arm2012.texinfo : debian/tmp/arm_form.exe
	cd source; ../debian/tmp/arm_form.exe RM info New-Only 3
	mv source/RM.texinfo $@
	sed -i 's/arm2005)\.$$/arm2012)./g' $@

debian/tmp/aarm2012.texinfo : debian/tmp/arm_form.exe
	cd source; ../debian/tmp/arm_form.exe AARM info New-Only 3
	mv source/AA.texinfo $@
	sed -i 's/arm2005)\.$$/arm2012)./g' $@

debian/tmp/arm_form.exe : force
	gnatmake -p -k -P debian/arm_info.gpr

debian/tmp source/Output source_2005/Output :
	mkdir $@

debian/tmp/%.ps : debian/tmp/%.dvi
	dvips -o $@ $<

debian/tmp/%.dvi : debian/tmp/%.texinfo | debian/tmp
	texi2dvi --quiet --tidy --build-dir=debian/tmp/$*.t2d -o $@ $<

clean:
	dh_clean
	rm -f build-stamp

binary: binary-indep binary-arch

binary-indep:
	dh_installchangelogs
	dh_installdocs
	dh_installinfo -pada-reference-manual-2005 debian/tmp/*2005.info
	dh_installinfo -pada-reference-manual-2012 debian/tmp/*2012.info
	dh_compress --exclude=.TXT
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# no architecture-dependent files
build-arch:
binary-arch:

lint:
	cd ..; lintian -i -I ada-reference-manual*.dsc

# end of file

=== debian/watch ===
version=3

# The upstream maintainer is the same person as the Debian maintainer,
# so there's no need for an automated scan.

# Intermediate upstream is in monotone, which has a web interface at
# http://green.ada-france.org:8081/branch/changes/org.debian.ada-reference-manual
# There might be a way to get uscan to recognize a new release there
# (a new tag?)

# Official upstream is at http://www.ada-auth.org/arm.html; there
# might be a way to get uscan to detect a new version there (once
# every 5 years or so).

## ada-reference-manual 2012.2

=== build/Makefile ===
# Compilation of the Scribe formatter written for the Ada Reference
# Manual, translating .ms[ms] files into various formats. Also build
# tar.gz for the web page.

# Copyright (c) 2010, 2013 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013       Nicolas Boulenguez <nicolas@debian.org>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# Specific targets generate every $document$year.$format combination.
# Ex: make arm2012.pdf
AVAILABLE_DOCUMENTS := aarm arm
AVAILABLE_YEARS     := 2005 2012
AVAILABLE_FORMATS   := html info texinfo txt pdf

# 'all' builds all versions except pdf; to build a subset, override these on the command line.
DOCUMENTS := $(AVAILABLE_DOCUMENTS)
YEARS     := $(AVAILABLE_YEARS)
FORMATS   := $(filter-out pdf texinfo, $(AVAILABLE_FORMATS))
# Texinfo is an intermediate, and is built as necessary.
# Pdf requires installation of many huge formatting tools; we assume they are not installed.

# see ../README.txt for list of things to change when Scribe or Ada source changes.
#
# Cygwin texi2dvi (GNU Texinfo 4.13) 1.135 fails silently!

# Debian standard build flags for Ada projects
BUILDER_OPTIONS := -k
ADAFLAGS        :=
LDFLAGS         :=
# arm_info.gpr sets its own flags, then appends these variables so
# that they take precedence.  The intent is that you may configure the
# build with a simple variable override.

.PHONY: all clean publish

all: $(foreach d,$(DOCUMENTS),\
     $(foreach y,$(YEARS),\
     $(foreach f,$(FORMATS),\
       $(d)$(y).$(f))))

# We have been unable to get rid of all the section ref violations, so we
# specify --no-validate. Delete that to see the errors.
TEXI_INFO_OPTS := --no-split --no-number-sections --no-validate
TEXI_PDF_OPTS := --quiet

SOURCE_DIR_2005 := ../source_2005
SOURCE_DIR_2012 := ../source_2012

# See progs/command.txt.
CHANGES      := New-Only
# See inside SOURCE_DIR_YEAR/DOCUMENT.msm for possible values.
VERSION_2005 := 2
VERSION_2012 := 3

# Mapping from document acronyms to Randy's file names
MASTER_arm  := rm.msm
MASTER_aarm := aarm.msm

# Rough dependency, but Scribe files should not change often.
SOURCES_2005 := $(wildcard $(SOURCE_DIR_2005)/*.ms[ms])
SOURCES_2012 := $(wildcard $(SOURCE_DIR_2012)/*.ms[ms])
define doc_year_build

  $(d)$(y).texinfo: arm_form.exe $(SOURCES_$(y))
	cd $(SOURCE_DIR_$(y)); \
        $(CURDIR)/$$< $(MASTER_$(d)) info $(CHANGES) $(VERSION_$(y)) $(CURDIR)/
	mv `sed -ne 's/^@FilePrefix{\(.*\)}/\L\1/p' $(SOURCE_DIR_$(y))/$(MASTER_$(d))`.texinfo $$@
  clean::
	rm -f $(d)$(y).texinfo

  $(d)$(y).html: arm_form.exe $(SOURCES_$(y))
	rm -f -r $$@
	mkdir --parents $$@
	cd $(SOURCE_DIR_$(y)); \
        $(CURDIR)/$$< $(MASTER_$(d)) HTML $(CHANGES) $(VERSION_$(y)) $(CURDIR)/$$@/
  clean::
	rm -f -r $(d)$(y).html

  $(d)$(y).txt: arm_form.exe $(SOURCES_$(y))
	rm -f -r $$@
	mkdir --parents $$@
	cd $(SOURCE_DIR_$(y)); \
        $(CURDIR)/$$< $(MASTER_$(d)) Text $(CHANGES) $(VERSION_$(y)) $(CURDIR)/$$@/
  clean::
	rm -f -r $(d)$(y).txt

# texi2any is from texinfo 5
  $(d)$(y).info: $(d)$(y).texinfo
	texi2any --info $(TEXI_INFO_OPTS) $$< -o $$@
  clean::
	rm -f $(d)$(y).info

  $(d)$(y).pdf: $(d)$(y).texinfo
	texi2any --pdf $(TEXI_PDF_OPTS) $$< -o $$@
  clean::
	rm -f $(d)$(y).log $(d)$(y).pdf $(d)$(y).toc

endef
$(foreach d,$(AVAILABLE_DOCUMENTS),\
$(foreach y,$(AVAILABLE_YEARS),\
$(eval $(doc_year_build))))

arm_form.exe : force
	gnatmake -p $(BUILDER_OPTIONS) -P arm_info.gpr $(foreach var,ADAFLAGS LDFLAGS,"-X$(var)=$($(var))")
clean::
	rm -f arm_form.exe
	rm -f -r objects

trace :
	addr2line -e arm_form.exe 0x5c12e7 0x5c598e 0x43e05b 0x446c5b 0x448369 0x545205 0x4e9221 0x4e3b1a 0x5831a1 0x5ad295 0x5adee9 0x4cb3f5 0x401850 0x401235 0x401286 0x7c817075

# year is latest standard; bump trailing digit for any change.
ZIP_VERSION := $(lastword $(AVAILABLE_YEARS)).2

INFO_ARCHIVE := arm_info-$(ZIP_VERSION).tar.gz
SOURCE_ARCHIVE  := arm_info-$(ZIP_VERSION)-src.tar.gz
publish: $(INFO_ARCHIVE) $(SOURCE_ARCHIVE)

# --no-name eliminates time stamps, which helps make the tarball reproducible
# --best gives higher compression than the default; we can afford the time here.
GZIP := --no-name --best

$(INFO_ARCHIVE): $(foreach d,$(DOCUMENTS),\
                 $(foreach y,$(YEARS),\
                 $(d)$(y).info))
	tar cf - $^ | gzip $(GZIP) -c > $@
clean::
	rm -f $(INFO_ARCHIVE)

ZIP_EXCLUDES := *~ *.dvi *.gz *.info *.log *.pdf *.ps *.texinfo *.toc \
  *.stamp *.zip arm_form.exe _MTN .mtn-ignore .dvc-exclude aarm2005.html \
  aarm2005.txt aarm2012.html aarm2012.txt arm2005.html arm2005.txt arm2012.html \
  arm2012.txt objects
$(SOURCE_ARCHIVE):
	tar cf - -C ../.. $(foreach e,$(ZIP_EXCLUDES),--exclude="$(e)") org.adaic.arm_form | gzip $(GZIP) -c > $@
clean::
	rm -f $(SOURCE_ARCHIVE)

update_upstream : source_ada.clean         source_ada.stamp
update_upstream : source_scribe_2005.clean source_scribe_2005.stamp
update_upstream : source_scribe_2012.clean source_scribe_2012.stamp

# download.py does not convert to unix line endings here to minimize
# the diff with upstream; the Ada compiler can handle DOS line endings
# on Unix. download.py does convert file names to lower case here, for
# consistency.
source_ada.stamp :
	rm -rf ../../org.adaic.arm_form.upstream/progs
	cd ../../org.adaic.arm_form.upstream; python3 ../org.adaic.arm_form/build/download.py progs
	touch source_ada.stamp

source_ada.clean :
	rm -f source_ada.stamp

# This retrieves the CVS tag for the year given on the command line
# commit to mtn: (dvc-status "../../org.adaic.arm_form.upstream")
#
# download.py converts to unix line endings here, because the scribe
# processor insists on uniform formatting; this works for both Windows
# and Debian. download.py also converts all file names to lowercase,
# and arm_form does as well; upstream only runs on Windows, which
# ignores case in filenames, so the file names in the sources are not
# consistently cased.
source_scribe_%.stamp :
	rm -rf ../../org.adaic.arm_form.upstream/source_$*
	cd ../../org.adaic.arm_form.upstream; python3 ../org.adaic.arm_form/build/download.py $*
	mv ../../org.adaic.arm_form.upstream/source ../../org.adaic.arm_form.upstream/source_$*
	touch source_scribe_$*.stamp

source_scribe_%.clean :
	rm -f source_scribe_$*.stamp

# These sources do not match teh correpsonding CVS tag, although they are close.
ARM_SRC.ZIP ARM_FORM.ZIP ARM_FSRC.ZIP 2005-SRC.zip 2012-SRC.zip :
	wget http://www.ada-auth.org/arm-files/$@

# delete everything back to mtn checkout
#
# Note that additional 'clean' targets are specified after every
# target that builds something.
clean ::
	rm -f *.stamp *.zip

info-clean :
	rm -f *.info*

.PHONY : force

VPATH = ../source_2005 ../source_2012 ../progs

#Local Variables:
#eval: (delete '("\\.mss\\'" . scribe-mode) auto-mode-alist)
#eval: (ada-parse-prj-file "arm_info.prj")
#eval: (ada-select-prj-file "arm_info.prj")
#End:
# end of file

=== debian/changelog ===
ada-reference-manual (1:2012.2-7) unstable; urgency=medium

  * Prepare compatibility with gnat 5 (versioned debian_packaging.mk)
    and > 5 (gnatmake will drop support for projects).

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 20 Oct 2015 14:47:12 +0200

ada-reference-manual (1:2012.2-6) unstable; urgency=medium

  * patches/specify-texinfo-encoding.diff closes: #790528

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 12 Jul 2015 19:31:36 +0200

ada-reference-manual (1:2012.2-5) unstable; urgency=medium

  * Not only set clock from deb log, but also freeze it so that PDF
    timestamps do not depend on the time spent in previous tasks.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 03 May 2015 15:08:49 +0200

ada-reference-manual (1:2012.2-4) unstable; urgency=medium

  * Remove dates from PDF generated by LaTeX, for reproducible builds.
  * Replace some txt duplicate docs with symlinks.
  * Standards-Version: 3.9.6 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 27 Apr 2015 15:30:27 +0200

ada-reference-manual (1:2012.2-3) unstable; urgency=medium

  * rules: avoid failing because of gnat 4.9 warnings.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 28 Apr 2014 18:26:24 +0200

ada-reference-manual (1:2012.2-2) unstable; urgency=medium

  * Build-Depends: debian_packaging.mk in gnat-x.y, not dh-ada-library.
  * patches/remove_race_condition_texinfo_tmpfile.diff closes: #743505.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 06 Apr 2014 11:42:45 +0200

ada-reference-manual (1:2012.2-1) unstable; urgency=low

  * New upstream release. Closes: #712363.
  * control: moved all Build-Depends to Build-Depends-Indep (no arch package).
    Build-Depend: dh-ada-library for Debian default Ada flags.
    Directly BD on texlive-fonts-recommended for ecrm1095 fonts.
    Only Break/Replace: a-r-m-info (no path conflict with other formats).
    No need to Conflict: obsolete gnat-doc (<< 3.15p) anymore.
    Added me to Uploaders. Added VCS-* fields.
  * README.Debian, arm_info.gpr: not specific to Debian, moved to upstream.
  * *.doc-base.*, *.docs: replaced with doc_base_template and loop in rules.
  * copyright: copyright-format/1.0, updated URL, .
  * source/local-options: only set non-default options.
  * watch: updated (thanks to bartm).

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Feb 2014 23:52:27 +0100

=== debian/control ===
Source: ada-reference-manual
Section: doc
Priority: optional
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends-Indep: debhelper (>= 9), dpkg-dev (>= 1.16.1),
# /usr/share/dpkg/default.mk
 gnat,
# Ada compiler, /usr/share/ada/debian_packaging*.mk
 faketime,
# https://wiki.debian.org/ReproducibleBuilds/TimestampsInPDFGeneratedByLaTeX
 texinfo,
# texi2any
 texlive-latex-recommended,
# pdf output module
 texlive-fonts-recommended
# ecrm1095 fonts
Standards-Version: 3.9.6
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.ada-reference-manual
Vcs-Mtn: www.ada-france.org org.debian.ada-reference-manual
Homepage: http://www.stephe-leake.org/ada/arm.html
# http://www.ada-auth.org/arm.html is the other upstream contact
# but Stephen's page links to them on the front page and this field
# only accepts one value.

Package: ada-reference-manual-2005
Architecture: all
Suggests: gnat
Breaks: ada-reference-manual-info
Replaces: ada-reference-manual-info
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Description: Ada 2005 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions of the 2005
 ARM in HTML, PDF, info, and plain text formats.

Package: ada-reference-manual-2012
Architecture: all
Suggests: gnat
Breaks: ada-reference-manual-info
Replaces: ada-reference-manual-info
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Description: Ada 2012 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions of the 2012
 ARM in HTML, PDF, info, and plain text formats.

=== debian/rules ===
#!/usr/bin/make -f
#
# Makefile for Ada Reference Manual.
# Copyright (c) 2010-2012 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013-2015 Nicolas Boulenguez <nicolas@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

define NEW_LINE


endef

DOCUMENTS := aarm arm
YEARS := 2005 2012

include /usr/share/dpkg/default.mk
# gnat-4.9 provides /usr/share/ada/debian_packaging.mk
# gnat-5   provides /usr/share/ada/debian_packaging-5.mk
include $(wildcard /usr/share/ada/debian_packaging*.mk)

ADAFLAGS += -gnat2005 -gnato -gnatVa -fstack-check

POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
 build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@

######################################################################
# Upstream Makefile is in the build directory.

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	$(MAKE) -C build clean

# Default settings do not produce PDF format.
FORMATS := html info txt pdf

# Faketime allows reproducible builds, see
# https://wiki.debian.org/ReproducibleBuilds/TimestampsInPDFGeneratedByLaTeX
# Freeze the clock so that the PDF timestamp does not depend on the
# time spent to generate then run the formatter.
DEB_DATE_RFC_2822 := $(shell dpkg-parsechangelog -S date)
DEB_DATE_RFC_3339 := $(shell date "+%F %T" -d "$(DEB_DATE_RFC_2822)")

.PHONY: override_dh_auto_build
override_dh_auto_build:
	faketime -f "$(DEB_DATE_RFC_3339)" \
	$(MAKE) -C build -j$(BUILDER_JOBS) \
          $(foreach v,ADAFLAGS BUILDER_OPTIONS FORMATS LDFLAGS,"$(v)=$($(v))")

######################################################################
.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --all --exclude=.TXT

######################################################################
.PHONY: override_dh_installinfo
override_dh_installinfo:
	$(foreach y,$(YEARS),dh_installinfo --package=ada-reference-manual-$(y)\
          $(foreach d,$(DOCUMENTS),build/$(d)$(y).info)$(NEW_LINE))
	dh_installinfo --remaining-packages

######################################################################
# Debhelper files for doc-base.

TITLE_aarm      := Annotated Ada Reference Manual
TITLE_arm       := Ada Reference Manual
FILEPREFIX_aarm := aa
FILEPREFIX_arm  := rm
ISO_2005        := 2007
ISO_2012        := 201x
ABSTRACT_aarm = The Annotated Ada Reference Manual, ISO/IEC \
 8652:$(ISO_$(y))(E). It contains the entire text of the Ada $(y) \
 standard, plus various annotations. It is intended primarily for \
 compiler writers, validation test writers, and other language \
 lawyers. The annotations include detailed rationale for individual \
 rules and explanations of some of the more arcane interactions among \
 the rules.
ABSTRACT_arm = The Ada Reference Manual, ISO/IEC \
 8652:$(ISO_$(y))(E). It contains the entire text of the Ada $(y) \
 standard.

define foreach_document_year_template

  DOC_BASE_GENERATED += debian/ada-reference-manual-$(y).doc-base.$(d)$(y)
  debian/ada-reference-manual-$(y).doc-base.$(d)$(y): debian/doc_base_template
	sed $$< \
           -e 's@DOCUMENT@$(d)@g' \
           -e 's@YEAR@$(y)@g' \
           -e 's@TITLE@$(TITLE_$(d))@g' \
           -e 's@ABSTRACT@$(ABSTRACT_$(d))@g' \
           -e 's@FILEPREFIX@$(FILEPREFIX_$(d))@g' \
           > $$@

endef
$(foreach d,$(DOCUMENTS),$(foreach y,$(YEARS),\
$(eval $(foreach_document_year_template))))

.PHONY: override_dh_installdocs
override_dh_installdocs: $(DOC_BASE_GENERATED)
	$(foreach y,$(YEARS),dh_installdocs --package=ada-reference-manual-$(y)\
          README.txt \
          $(foreach d,$(DOCUMENTS),build/$(d)$(y).html\
                                   build/$(d)$(y).txt\
                                   build/$(d)$(y).pdf)$(NEW_LINE))
	dh_installdocs --remaining-packages

clean: doc_base_clean
doc_base_clean:
	rm --force $(DOC_BASE_GENERATED)
.PHONY: doc_base_clean

######################################################################
# Check that some .txt docs are still duplicates, then symlink.

.PHONY: override_dh_link
override_dh_link:
	$(foreach y,$(YEARS), \
	$(foreach c,Lib TOC, \
	diff -q \
	  debian/ada-reference-manual-$(y)/usr/share/doc/ada-reference-manual-$(y)/aarm$(y).txt/aa-$(c).TXT \
	  debian/ada-reference-manual-$(y)/usr/share/doc/ada-reference-manual-$(y)/arm$(y).txt/rm-$(c).TXT$(NEW_LINE) \
	dh_link --package=ada-reference-manual-$(y) \
	  usr/share/doc/ada-reference-manual-$(y)/aarm$(y).txt/aa-$(c).TXT \
	  usr/share/doc/ada-reference-manual-$(y)/arm$(y).txt/rm-$(c).TXT$(NEW_LINE)))
	dh_link --remaining-packages

=== debian/watch ===
version=3
http://www.stephe-leake.org/ada/arm.html arm_info-(\d.*)-src\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
